Filtering can be applied to Tree Data to reduce the range of displayed data.
Filtering Copy Link
By default, when a group row passes a Filter, the children will also be displayed.
The example below applies a filter to the group column for 'ProjectAlpha', note that two 'ProjectAlpha' groups are displayed alongside all of their children.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { TreeDataModule } from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
TreeDataModule,
TextFilterModule,
]);
let gridApi: GridApi;
const gridOptions: GridOptions = {
columnDefs: [
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
],
defaultColDef: {
flex: 1,
},
autoGroupColumnDef: {
headerName: "File Explorer",
minWidth: 150,
filter: "agTextColumnFilter",
cellRendererParams: {
suppressCount: true,
},
},
rowData: getData(),
treeData: true,
groupDefaultExpanded: -1,
getDataPath: (data) => data.path,
onGridReady: (event) => {
gridApi.setFilterModel({
"ag-Grid-AutoColumn": {
filterType: "text",
type: "startsWith",
filter: "ProjectAlpha",
},
});
},
};
// wait for the document to be loaded, otherwise
// AG Grid will not find the div in the document.
// lookup the container we want the Grid to use
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
// create the grid passing in the div to use together with the columns & data we want to use
gridApi = createGrid(gridDiv, gridOptions);
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
<div id="myGrid" style="height: 100%"></div>
Exclude Children when Filtering Copy Link
To omit children when a group row passes a filter, set excludeChildrenWhenTreeDataFiltering to true in the grid options.
The example below applies a default filter to the group column for 'ProjectAlpha', note that only one 'ProjectAlpha' group passes the filter instead of two - this is because the Desktop -> ProjectAlpha group is a Filler Group.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { TreeDataModule } from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
TreeDataModule,
TextFilterModule,
]);
let gridApi: GridApi;
const gridOptions: GridOptions = {
columnDefs: [
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
],
defaultColDef: {
flex: 1,
},
autoGroupColumnDef: {
headerName: "File Explorer",
minWidth: 150,
filter: "agTextColumnFilter",
cellRendererParams: {
suppressCount: true,
},
},
rowData: getData(),
treeData: true,
groupDefaultExpanded: -1,
excludeChildrenWhenTreeDataFiltering: true,
getDataPath: (data) => data.path,
onGridReady: (event) => {
gridApi.setFilterModel({
"ag-Grid-AutoColumn": {
filterType: "text",
type: "startsWith",
filter: "ProjectAlpha",
},
});
},
};
function toggleFilter() {
const checkbox = document.querySelector<HTMLInputElement>(
"#excludeChildrenWhenTreeDataFiltering",
)!;
gridApi.setGridOption(
"excludeChildrenWhenTreeDataFiltering",
checkbox.checked,
);
}
// wait for the document to be loaded, otherwise
// AG Grid will not find the div in the document.
// lookup the container we want the Grid to use
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
// create the grid passing in the div to use together with the columns & data we want to use
gridApi = createGrid(gridDiv, gridOptions);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).toggleFilter = toggleFilter;
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
.example-header {
margin-bottom: 10px;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
<div class="example-wrapper">
<div class="example-header">
<label>
<span>excludeChildrenWhenTreeDataFiltering:</span>
<input type="checkbox" id="excludeChildrenWhenTreeDataFiltering" onclick="toggleFilter()" checked />
</label>
</div>
<div id="myGrid" style="height: 100%"></div>
</div>
This demonstrates the following configuration:
const gridOptions = {
excludeChildrenWhenTreeDataFiltering: true,
// other grid options ...
} Ignore Filters when Aggregating Values Copy Link
When using Tree Data and filters, the aggregates are only calculated from the rows which pass the filter. This can be changed by enabling the grid option suppressAggFilteredOnly.
The example below has a filter applied resulting in only one of the Documents children being displayed. Note that when the suppressAggFilteredOnly option is toggled on, the Documents group aggregation will display the sum of all children, regardless of the filter.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { TreeDataModule } from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
ClientSideRowModelModule,
TreeDataModule,
NumberFilterModule,
]);
let gridApi: GridApi;
const gridOptions: GridOptions = {
columnDefs: [
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
filter: "agNumberColumnFilter",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
],
defaultColDef: {
flex: 1,
},
autoGroupColumnDef: {
headerName: "File Explorer",
minWidth: 150,
cellRendererParams: {
suppressCount: true,
},
},
rowData: getData(),
treeData: true,
groupDefaultExpanded: 1,
suppressAggFilteredOnly: true,
getDataPath: (data) => data.path,
onGridReady: (event) => {
gridApi.setFilterModel({
size: {
filterType: "number",
type: "equals",
filter: 5193728,
},
});
},
};
function toggleCheckbox() {
const checkbox = document.querySelector<HTMLInputElement>(
"#suppressAggFilteredOnly",
)!;
gridApi.setGridOption("suppressAggFilteredOnly", checkbox.checked);
}
// wait for the document to be loaded, otherwise
// AG Grid will not find the div in the document.
// lookup the container we want the Grid to use
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
// create the grid passing in the div to use together with the columns & data we want to use
gridApi = createGrid(gridDiv, gridOptions);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).toggleCheckbox = toggleCheckbox;
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
.fa-folder {
color: darkorange;
}
.fa-file-pdf {
color: red;
}
.fa-file-excel {
color: green;
}
.fa-file-audio {
color: blue;
}
.filename {
padding: 5px;
color: black;
font-size: 16px;
}
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
<div class="example-wrapper">
<label>
suppressAggFilteredOnly:
<input type="checkbox" id="suppressAggFilteredOnly" checked onclick="toggleCheckbox()" />
</label>
<div id="myGrid"></div>
</div>
This demonstrates the following configuration:
const gridOptions = {
suppressAggFilteredOnly: true,
// other grid options ...
} Filter Components Copy Link
Tree Filter Copy Link
The Tree Filter is a version of the Set Filter that is designed to work with hierarchical data by displaying the set filter in a tree structure that matches the data.
The example below demonstrates the Tree Filter on the Group column:
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
SetFilterModule,
TreeDataModule,
} from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
SetFilterModule,
TreeDataModule,
]);
let gridApi: GridApi;
const gridOptions: GridOptions = {
columnDefs: [
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
],
defaultColDef: {
flex: 1,
minWidth: 200,
},
autoGroupColumnDef: {
cellRendererParams: {
suppressCount: true,
},
filter: "agSetColumnFilter",
filterParams: {
treeList: true,
keyCreator: (params) => (params.value ? params.value.join("#") : null),
},
},
treeData: true,
groupDefaultExpanded: -1,
getDataPath: (data: any) => data.path,
rowData: getData(),
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
<div id="myGrid" style="height: 100%"></div>
This demonstrates the following configuration to enable the Tree List Filter. Note that a keyCreator must be used to convert each path into a unique string:
const gridOptions = {
autoGroupColumnDef: {
filter: 'agSetColumnFilter',
filterParams: {
treeList: true,
keyCreator: (params) => (params.value ? params.value.join('#') : null),
},
},
// other grid options ...
}For further information, refer to the Tree Filter documentation.
Set Filter Copy Link
The Set Filter can be used with Tree Data to list all unique values across each level of the group hierarchy.
The example below demonstrates the Set Filter on the Size column.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
ValueFormatterParams,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
SetFilterModule,
TreeDataModule,
} from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
SetFilterModule,
TreeDataModule,
]);
let gridApi: GridApi;
const gridOptions: GridOptions = {
columnDefs: [
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
filter: "agSetColumnFilter",
filterParams: {
valueFormatter: (params: ValueFormatterParams) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
],
defaultColDef: {
flex: 1,
minWidth: 200,
},
autoGroupColumnDef: {
cellRendererParams: {
suppressCount: true,
},
},
treeData: true,
groupDefaultExpanded: -1,
groupAggFiltering: true,
getDataPath: (data: any) => data.path,
rowData: getData(),
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
<div id="myGrid" style="height: 100%"></div>
When using the Set Filter with Aggregations the set filter options can change when applying filters.
To prevent this it is advised that you Enable Aggregate Value Filtering.

Filtering can be applied to Tree Data to reduce the range of displayed data.
Filtering Copy Link
By default, when a group row passes a Filter, the children will also be displayed.
The example below applies a filter to the group column for 'ProjectAlpha', note that two 'ProjectAlpha' groups are displayed alongside all of their children.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetDataPath,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { TreeDataModule } from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
TreeDataModule,
TextFilterModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[rowData]="rowData"
[treeData]="true"
[groupDefaultExpanded]="groupDefaultExpanded"
[getDataPath]="getDataPath"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
];
defaultColDef: ColDef = {
flex: 1,
};
autoGroupColumnDef: AutoGroupColumnDef = {
headerName: "File Explorer",
minWidth: 150,
filter: "agTextColumnFilter",
cellRendererParams: {
suppressCount: true,
},
};
rowData: any[] | null = getData();
groupDefaultExpanded = -1;
getDataPath: GetDataPath = (data) => data.path;
onGridReady(params: GridReadyEvent) {
params.api.setFilterModel({
"ag-Grid-AutoColumn": {
filterType: "text",
type: "startsWith",
filter: "ProjectAlpha",
},
});
}
}
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Exclude Children when Filtering Copy Link
To omit children when a group row passes a filter, set excludeChildrenWhenTreeDataFiltering to true in the grid options.
The example below applies a default filter to the group column for 'ProjectAlpha', note that only one 'ProjectAlpha' group passes the filter instead of two - this is because the Desktop -> ProjectAlpha group is a Filler Group.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetDataPath,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { TreeDataModule } from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
TreeDataModule,
TextFilterModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="example-wrapper">
<div class="example-header">
<label>
<span>excludeChildrenWhenTreeDataFiltering:</span>
<input
type="checkbox"
id="excludeChildrenWhenTreeDataFiltering"
(click)="toggleFilter()"
checked=""
/>
</label>
</div>
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[rowData]="rowData"
[treeData]="true"
[groupDefaultExpanded]="groupDefaultExpanded"
[excludeChildrenWhenTreeDataFiltering]="true"
[getDataPath]="getDataPath"
(gridReady)="onGridReady($event)"
/>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi;
columnDefs: ColDef[] = [
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
];
defaultColDef: ColDef = {
flex: 1,
};
autoGroupColumnDef: AutoGroupColumnDef = {
headerName: "File Explorer",
minWidth: 150,
filter: "agTextColumnFilter",
cellRendererParams: {
suppressCount: true,
},
};
rowData: any[] | null = getData();
groupDefaultExpanded = -1;
getDataPath: GetDataPath = (data) => data.path;
toggleFilter() {
const checkbox = document.querySelector<HTMLInputElement>(
"#excludeChildrenWhenTreeDataFiltering",
)!;
this.gridApi.setGridOption(
"excludeChildrenWhenTreeDataFiltering",
checkbox.checked,
);
}
onGridReady(params: GridReadyEvent) {
this.gridApi = params.api;
params.api.setFilterModel({
"ag-Grid-AutoColumn": {
filterType: "text",
type: "startsWith",
filter: "ProjectAlpha",
},
});
}
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
.example-header {
margin-bottom: 10px;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
This demonstrates the following configuration:
<ag-grid-angular
[excludeChildrenWhenTreeDataFiltering]="excludeChildrenWhenTreeDataFiltering"
/* other grid options ... */ />
this.excludeChildrenWhenTreeDataFiltering = true; Ignore Filters when Aggregating Values Copy Link
When using Tree Data and filters, the aggregates are only calculated from the rows which pass the filter. This can be changed by enabling the grid option suppressAggFilteredOnly.
The example below has a filter applied resulting in only one of the Documents children being displayed. Note that when the suppressAggFilteredOnly option is toggled on, the Documents group aggregation will display the sum of all children, regardless of the filter.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetDataPath,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { TreeDataModule } from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
ClientSideRowModelModule,
TreeDataModule,
NumberFilterModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="example-wrapper">
<label>
suppressAggFilteredOnly:
<input
type="checkbox"
id="suppressAggFilteredOnly"
checked=""
(click)="toggleCheckbox()"
/>
</label>
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[rowData]="rowData"
[treeData]="true"
[groupDefaultExpanded]="groupDefaultExpanded"
[suppressAggFilteredOnly]="true"
[getDataPath]="getDataPath"
(gridReady)="onGridReady($event)"
/>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi;
columnDefs: ColDef[] = [
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
filter: "agNumberColumnFilter",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
];
defaultColDef: ColDef = {
flex: 1,
};
autoGroupColumnDef: AutoGroupColumnDef = {
headerName: "File Explorer",
minWidth: 150,
cellRendererParams: {
suppressCount: true,
},
};
rowData: any[] | null = getData();
groupDefaultExpanded = 1;
getDataPath: GetDataPath = (data) => data.path;
toggleCheckbox() {
const checkbox = document.querySelector<HTMLInputElement>(
"#suppressAggFilteredOnly",
)!;
this.gridApi.setGridOption("suppressAggFilteredOnly", checkbox.checked);
}
onGridReady(params: GridReadyEvent) {
this.gridApi = params.api;
params.api.setFilterModel({
size: {
filterType: "number",
type: "equals",
filter: 5193728,
},
});
}
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
.fa-folder {
color: darkorange;
}
.fa-file-pdf {
color: red;
}
.fa-file-excel {
color: green;
}
.fa-file-audio {
color: blue;
}
.filename {
padding: 5px;
color: black;
font-size: 16px;
}
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
This demonstrates the following configuration:
<ag-grid-angular
[suppressAggFilteredOnly]="suppressAggFilteredOnly"
/* other grid options ... */ />
this.suppressAggFilteredOnly = true; Filter Components Copy Link
Tree Filter Copy Link
The Tree Filter is a version of the Set Filter that is designed to work with hierarchical data by displaying the set filter in a tree structure that matches the data.
The example below demonstrates the Tree Filter on the Group column:
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetDataPath,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
SetFilterModule,
TreeDataModule,
} from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
SetFilterModule,
TreeDataModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[treeData]="true"
[groupDefaultExpanded]="groupDefaultExpanded"
[getDataPath]="getDataPath"
[rowData]="rowData"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 200,
};
autoGroupColumnDef: AutoGroupColumnDef = {
cellRendererParams: {
suppressCount: true,
},
filter: "agSetColumnFilter",
filterParams: {
treeList: true,
keyCreator: (params) => (params.value ? params.value.join("#") : null),
},
};
groupDefaultExpanded = -1;
getDataPath: GetDataPath = (data: any) => data.path;
rowData: any[] | null = getData();
}
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
This demonstrates the following configuration to enable the Tree List Filter. Note that a keyCreator must be used to convert each path into a unique string:
<ag-grid-angular
[autoGroupColumnDef]="autoGroupColumnDef"
/* other grid options ... */ />
this.autoGroupColumnDef = {
filter: 'agSetColumnFilter',
filterParams: {
treeList: true,
keyCreator: (params) => (params.value ? params.value.join('#') : null),
},
};For further information, refer to the Tree Filter documentation.
Set Filter Copy Link
The Set Filter can be used with Tree Data to list all unique values across each level of the group hierarchy.
The example below demonstrates the Set Filter on the Size column.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetDataPath,
GridApi,
GridOptions,
GridReadyEvent,
IsRowFilterable,
ModuleRegistry,
ValueFormatterParams,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
SetFilterModule,
TreeDataModule,
} from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
SetFilterModule,
TreeDataModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[treeData]="true"
[groupDefaultExpanded]="groupDefaultExpanded"
[groupAggFiltering]="true"
[getDataPath]="getDataPath"
[rowData]="rowData"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
filter: "agSetColumnFilter",
filterParams: {
valueFormatter: (params: ValueFormatterParams) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 200,
};
autoGroupColumnDef: AutoGroupColumnDef = {
cellRendererParams: {
suppressCount: true,
},
};
groupDefaultExpanded = -1;
getDataPath: GetDataPath = (data: any) => data.path;
rowData: any[] | null = getData();
}
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
When using the Set Filter with Aggregations the set filter options can change when applying filters.
To prevent this it is advised that you Enable Aggregate Value Filtering.

Filtering can be applied to Tree Data to reduce the range of displayed data.
Filtering Copy Link
By default, when a group row passes a Filter, the children will also be displayed.
The example below applies a filter to the group column for 'ProjectAlpha', note that two 'ProjectAlpha' groups are displayed alongside all of their children.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetDataPath,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { TreeDataModule } from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
TreeDataModule,
TextFilterModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:rowData="rowData"
:treeData="true"
:groupDefaultExpanded="groupDefaultExpanded"
:getDataPath="getDataPath"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
headerName: "File Explorer",
minWidth: 150,
filter: "agTextColumnFilter",
cellRendererParams: {
suppressCount: true,
},
});
const rowData = ref<any[] | null>(getData());
const groupDefaultExpanded = ref(-1);
const getDataPath = ref<GetDataPath>((data) => data.path);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
params.api.setFilterModel({
"ag-Grid-AutoColumn": {
filterType: "text",
type: "startsWith",
filter: "ProjectAlpha",
},
});
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
rowData,
groupDefaultExpanded,
getDataPath,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
Exclude Children when Filtering Copy Link
To omit children when a group row passes a filter, set excludeChildrenWhenTreeDataFiltering to true in the grid options.
The example below applies a default filter to the group column for 'ProjectAlpha', note that only one 'ProjectAlpha' group passes the filter instead of two - this is because the Desktop -> ProjectAlpha group is a Filler Group.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetDataPath,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { TreeDataModule } from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
TreeDataModule,
TextFilterModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="example-wrapper">
<div class="example-header">
<label>
<span>excludeChildrenWhenTreeDataFiltering:</span>
<input type="checkbox" id="excludeChildrenWhenTreeDataFiltering" v-on:click="toggleFilter()" checked="">
</label>
</div>
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:rowData="rowData"
:treeData="true"
:groupDefaultExpanded="groupDefaultExpanded"
:excludeChildrenWhenTreeDataFiltering="true"
:getDataPath="getDataPath"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
headerName: "File Explorer",
minWidth: 150,
filter: "agTextColumnFilter",
cellRendererParams: {
suppressCount: true,
},
});
const rowData = ref<any[] | null>(getData());
const groupDefaultExpanded = ref(-1);
const getDataPath = ref<GetDataPath>((data) => data.path);
function toggleFilter() {
const checkbox = document.querySelector<HTMLInputElement>(
"#excludeChildrenWhenTreeDataFiltering",
)!;
gridApi.value.setGridOption(
"excludeChildrenWhenTreeDataFiltering",
checkbox.checked,
);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
params.api.setFilterModel({
"ag-Grid-AutoColumn": {
filterType: "text",
type: "startsWith",
filter: "ProjectAlpha",
},
});
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
rowData,
groupDefaultExpanded,
getDataPath,
onGridReady,
toggleFilter,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
.example-header {
margin-bottom: 10px;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
This demonstrates the following configuration:
<ag-grid-vue
:excludeChildrenWhenTreeDataFiltering="excludeChildrenWhenTreeDataFiltering"
/* other grid options ... */>
</ag-grid-vue>
this.excludeChildrenWhenTreeDataFiltering = true; Ignore Filters when Aggregating Values Copy Link
When using Tree Data and filters, the aggregates are only calculated from the rows which pass the filter. This can be changed by enabling the grid option suppressAggFilteredOnly.
The example below has a filter applied resulting in only one of the Documents children being displayed. Note that when the suppressAggFilteredOnly option is toggled on, the Documents group aggregation will display the sum of all children, regardless of the filter.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetDataPath,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { TreeDataModule } from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
ClientSideRowModelModule,
TreeDataModule,
NumberFilterModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="example-wrapper">
<label>
suppressAggFilteredOnly:
<input type="checkbox" id="suppressAggFilteredOnly" checked="" v-on:click="toggleCheckbox()">
</label>
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:rowData="rowData"
:treeData="true"
:groupDefaultExpanded="groupDefaultExpanded"
:suppressAggFilteredOnly="true"
:getDataPath="getDataPath"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
filter: "agNumberColumnFilter",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
headerName: "File Explorer",
minWidth: 150,
cellRendererParams: {
suppressCount: true,
},
});
const rowData = ref<any[] | null>(getData());
const groupDefaultExpanded = ref(1);
const getDataPath = ref<GetDataPath>((data) => data.path);
function toggleCheckbox() {
const checkbox = document.querySelector<HTMLInputElement>(
"#suppressAggFilteredOnly",
)!;
gridApi.value.setGridOption("suppressAggFilteredOnly", checkbox.checked);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
params.api.setFilterModel({
size: {
filterType: "number",
type: "equals",
filter: 5193728,
},
});
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
rowData,
groupDefaultExpanded,
getDataPath,
onGridReady,
toggleCheckbox,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
.fa-folder {
color: darkorange;
}
.fa-file-pdf {
color: red;
}
.fa-file-excel {
color: green;
}
.fa-file-audio {
color: blue;
}
.filename {
padding: 5px;
color: black;
font-size: 16px;
}
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
This demonstrates the following configuration:
<ag-grid-vue
:suppressAggFilteredOnly="suppressAggFilteredOnly"
/* other grid options ... */>
</ag-grid-vue>
this.suppressAggFilteredOnly = true; Filter Components Copy Link
Tree Filter Copy Link
The Tree Filter is a version of the Set Filter that is designed to work with hierarchical data by displaying the set filter in a tree structure that matches the data.
The example below demonstrates the Tree Filter on the Group column:
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetDataPath,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
SetFilterModule,
TreeDataModule,
} from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
SetFilterModule,
TreeDataModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:treeData="true"
:groupDefaultExpanded="groupDefaultExpanded"
:getDataPath="getDataPath"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 200,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
cellRendererParams: {
suppressCount: true,
},
filter: "agSetColumnFilter",
filterParams: {
treeList: true,
keyCreator: (params) => (params.value ? params.value.join("#") : null),
},
});
const groupDefaultExpanded = ref(-1);
const getDataPath = ref<GetDataPath>((data: any) => data.path);
const rowData = ref<any[] | null>(getData());
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
groupDefaultExpanded,
getDataPath,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
This demonstrates the following configuration to enable the Tree List Filter. Note that a keyCreator must be used to convert each path into a unique string:
<ag-grid-vue
:autoGroupColumnDef="autoGroupColumnDef"
/* other grid options ... */>
</ag-grid-vue>
this.autoGroupColumnDef = {
filter: 'agSetColumnFilter',
filterParams: {
treeList: true,
keyCreator: (params) => (params.value ? params.value.join('#') : null),
},
};For further information, refer to the Tree Filter documentation.
Set Filter Copy Link
The Set Filter can be used with Tree Data to list all unique values across each level of the group hierarchy.
The example below demonstrates the Set Filter on the Size column.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetDataPath,
GridApi,
GridOptions,
GridReadyEvent,
IsRowFilterable,
ModuleRegistry,
ValueFormatterParams,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
SetFilterModule,
TreeDataModule,
} from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
SetFilterModule,
TreeDataModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:treeData="true"
:groupDefaultExpanded="groupDefaultExpanded"
:groupAggFiltering="true"
:getDataPath="getDataPath"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
filter: "agSetColumnFilter",
filterParams: {
valueFormatter: (params: ValueFormatterParams) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 200,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
cellRendererParams: {
suppressCount: true,
},
});
const groupDefaultExpanded = ref(-1);
const getDataPath = ref<GetDataPath>((data: any) => data.path);
const rowData = ref<any[] | null>(getData());
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
groupDefaultExpanded,
getDataPath,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
When using the Set Filter with Aggregations the set filter options can change when applying filters.
To prevent this it is advised that you Enable Aggregate Value Filtering.

Filtering can be applied to Tree Data to reduce the range of displayed data.
Filtering Copy Link
By default, when a group row passes a Filter, the children will also be displayed.
The example below applies a filter to the group column for 'ProjectAlpha', note that two 'ProjectAlpha' groups are displayed alongside all of their children.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetDataPath,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { TreeDataModule } from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [ClientSideRowModelModule, TreeDataModule, TextFilterModule];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<any[]>(getData());
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
headerName: "File Explorer",
minWidth: 150,
filter: "agTextColumnFilter",
cellRendererParams: {
suppressCount: true,
},
};
}, []);
const getDataPath = useCallback((data) => data.path, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
params.api.setFilterModel({
"ag-Grid-AutoColumn": {
filterType: "text",
type: "startsWith",
filter: "ProjectAlpha",
},
});
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
treeData={true}
groupDefaultExpanded={-1}
getDataPath={getDataPath}
onGridReady={onGridReady}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
Exclude Children when Filtering Copy Link
To omit children when a group row passes a filter, set excludeChildrenWhenTreeDataFiltering to true in the grid options.
The example below applies a default filter to the group column for 'ProjectAlpha', note that only one 'ProjectAlpha' group passes the filter instead of two - this is because the Desktop -> ProjectAlpha group is a Filler Group.
'use client';
import React, {
StrictMode,
useCallback,
useMemo,
useRef,
useState,
} from "react";
import { createRoot } from "react-dom/client";
import type { ColDef, GridReadyEvent } from "ag-grid-community";
import {
ClientSideRowModelModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { TreeDataModule } from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact } from "ag-grid-react";
import { getData } from "./data";
import "./styles.css";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [TextFilterModule, ClientSideRowModelModule, TreeDataModule];
const GridExample = () => {
const gridRef = useRef<AgGridReact>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<any[]>(getData());
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
};
}, []);
const autoGroupColumnDef = useMemo<ColDef>(() => {
return {
headerName: "File Explorer",
minWidth: 150,
filter: "agTextColumnFilter",
cellRendererParams: {
suppressCount: true,
},
};
}, []);
const getDataPath = useCallback((data) => data.path, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
params.api.setFilterModel({
"ag-Grid-AutoColumn": {
filterType: "text",
type: "startsWith",
filter: "ProjectAlpha",
},
});
}, []);
const toggleFilter = useCallback(() => {
const checkbox = document.querySelector<HTMLInputElement>(
"#excludeChildrenWhenTreeDataFiltering",
)!;
gridRef.current!.api.setGridOption(
"excludeChildrenWhenTreeDataFiltering",
checkbox.checked,
);
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="example-wrapper">
<div className="example-header">
<label>
<span>excludeChildrenWhenTreeDataFiltering:</span>
<input
type="checkbox"
id="excludeChildrenWhenTreeDataFiltering"
onClick={toggleFilter}
defaultChecked
/>
</label>
</div>
<div style={gridStyle}>
<AgGridReact
ref={gridRef}
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
treeData={true}
groupDefaultExpanded={-1}
excludeChildrenWhenTreeDataFiltering={true}
getDataPath={getDataPath}
onGridReady={onGridReady}
/>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
.example-header {
margin-bottom: 10px;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
const files = [
{
path: ["Desktop", "ProjectAlpha", "Proposal.docx"],
size: 512000,
created: "2023-07-10",
modified: "2023-08-01",
},
{
path: ["Desktop", "ProjectAlpha", "Timeline.xlsx"],
size: 1048576,
created: "2023-07-12",
modified: "2023-08-03",
},
{
path: ["Desktop", "ToDoList.txt"],
size: 51200,
created: "2023-08-05",
modified: "2023-08-10",
},
{
path: ["Desktop", "MeetingNotes_August.pdf"],
size: 460800,
created: "2023-08-15",
modified: "2023-08-15",
},
{ path: ["Documents", "Work", "ProjectAlpha"] },
{
path: ["Documents", "Work", "ProjectAlpha", "Proposal.docx"],
size: 512000,
created: "2023-07-10",
modified: "2023-08-01",
},
{
path: ["Documents", "Work", "ProjectAlpha", "Timeline.xlsx"],
size: 1048576,
created: "2023-07-12",
modified: "2023-08-03",
},
{
path: ["Documents", "Work", "ProjectBeta", "Report.pdf"],
size: 1024000,
created: "2023-06-22",
modified: "2023-07-15",
},
{
path: ["Documents", "Work", "ProjectBeta", "Budget.xlsx"],
size: 1048576,
created: "2023-06-25",
modified: "2023-07-18",
},
{
path: ["Documents", "Work", "Meetings", "TeamMeeting_August.pdf"],
size: 512000,
created: "2023-08-20",
modified: "2023-08-21",
},
{
path: ["Documents", "Work", "Meetings", "ClientMeeting_July.pdf"],
size: 1048576,
created: "2023-07-15",
modified: "2023-07-16",
},
{
path: ["Documents", "Personal", "Taxes", "2022.pdf"],
size: 1024000,
created: "2023-04-10",
modified: "2023-04-10",
},
{
path: ["Documents", "Personal", "Taxes", "2021.pdf"],
size: 1048576,
created: "2022-04-05",
modified: "2022-04-06",
},
{
path: ["Documents", "Personal", "Taxes", "2020.pdf"],
size: 1024000,
created: "2021-04-03",
modified: "2021-04-03",
},
{
path: ["Pictures", "Vacation2019", "Beach.jpg"],
size: 1048576,
created: "2019-07-10",
modified: "2019-07-12",
},
{
path: ["Pictures", "Vacation2019", "Mountain.png"],
size: 2048000,
created: "2019-07-11",
modified: "2019-07-13",
},
{
path: ["Pictures", "Family", "Birthday2022.jpg"],
size: 3072000,
created: "2022-12-15",
modified: "2022-12-20",
},
{
path: ["Pictures", "Family", "Christmas2021.png"],
size: 2048000,
created: "2021-12-25",
modified: "2021-12-26",
},
{
path: ["Videos", "Vacation2019", "Beach.mov"],
size: 4194304,
created: "2019-07-10",
modified: "2019-07-12",
},
{
path: ["Videos", "Vacation2019", "Hiking.mp4"],
size: 4194304,
created: "2019-07-15",
modified: "2019-07-16",
},
{
path: ["Videos", "Family", "Birthday2022.mp4"],
size: 6291456,
created: "2022-12-15",
modified: "2022-12-20",
},
{
path: ["Videos", "Family", "Christmas2021.mov"],
size: 6291456,
created: "2021-12-25",
modified: "2021-12-26",
},
{
path: ["Downloads", "SoftwareInstaller.exe"],
size: 2097152,
created: "2023-08-01",
modified: "2023-08-01",
},
{
path: ["Downloads", "Receipt_OnlineStore.pdf"],
size: 1048576,
created: "2023-08-05",
modified: "2023-08-05",
},
{
path: ["Downloads", "Ebook.pdf"],
size: 1048576,
created: "2023-08-08",
modified: "2023-08-08",
},
];
export function getData() {
return files;
}
This demonstrates the following configuration:
const excludeChildrenWhenTreeDataFiltering = true;
<AgGridReact excludeChildrenWhenTreeDataFiltering={excludeChildrenWhenTreeDataFiltering} /> Ignore Filters when Aggregating Values Copy Link
When using Tree Data and filters, the aggregates are only calculated from the rows which pass the filter. This can be changed by enabling the grid option suppressAggFilteredOnly.
The example below has a filter applied resulting in only one of the Documents children being displayed. Note that when the suppressAggFilteredOnly option is toggled on, the Documents group aggregation will display the sum of all children, regardless of the filter.
'use client';
import React, {
StrictMode,
useCallback,
useMemo,
useRef,
useState,
} from "react";
import { createRoot } from "react-dom/client";
import type { ColDef, GridReadyEvent } from "ag-grid-community";
import {
ClientSideRowModelModule,
NumberFilterModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { TreeDataModule } from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact } from "ag-grid-react";
import { getData } from "./data";
import "./styles.css";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberFilterModule,
TextFilterModule,
ClientSideRowModelModule,
TreeDataModule,
];
const GridExample = () => {
const gridRef = useRef<AgGridReact>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<any[]>(getData());
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
filter: "agNumberColumnFilter",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
};
}, []);
const autoGroupColumnDef = useMemo<ColDef>(() => {
return {
headerName: "File Explorer",
minWidth: 150,
cellRendererParams: {
suppressCount: true,
},
};
}, []);
const getDataPath = useCallback((data) => data.path, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
params.api.setFilterModel({
size: {
filterType: "number",
type: "equals",
filter: 5193728,
},
});
}, []);
const toggleCheckbox = useCallback(() => {
const checkbox = document.querySelector<HTMLInputElement>(
"#suppressAggFilteredOnly",
)!;
gridRef.current!.api.setGridOption(
"suppressAggFilteredOnly",
checkbox.checked,
);
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="example-wrapper">
<div className="example-header">
<label>
<span>suppressAggFilteredOnly:</span>
<input
type="checkbox"
id="suppressAggFilteredOnly"
onClick={toggleCheckbox}
defaultChecked
/>
</label>
</div>
<div style={gridStyle}>
<AgGridReact
ref={gridRef}
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
treeData={true}
groupDefaultExpanded={1}
suppressAggFilteredOnly={true}
getDataPath={getDataPath}
onGridReady={onGridReady}
/>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
.fa-folder {
color: darkorange;
}
.fa-file-pdf {
color: red;
}
.fa-file-excel {
color: green;
}
.fa-file-audio {
color: blue;
}
.filename {
padding: 5px;
color: black;
font-size: 16px;
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
.example-header {
margin-bottom: 10px;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
const files = [
{
path: ["Desktop", "ProjectAlpha", "Proposal.docx"],
size: 512000,
created: "2023-07-10",
modified: "2023-08-01",
},
{
path: ["Desktop", "ProjectAlpha", "Timeline.xlsx"],
size: 1048576,
created: "2023-07-12",
modified: "2023-08-03",
},
{
path: ["Desktop", "ToDoList.txt"],
size: 51200,
created: "2023-08-05",
modified: "2023-08-10",
},
{
path: ["Desktop", "MeetingNotes_August.pdf"],
size: 460800,
created: "2023-08-15",
modified: "2023-08-15",
},
{ path: ["Documents", "Work", "ProjectAlpha"] },
{
path: ["Documents", "Work", "ProjectAlpha", "Proposal.docx"],
size: 512000,
created: "2023-07-10",
modified: "2023-08-01",
},
{
path: ["Documents", "Work", "ProjectAlpha", "Timeline.xlsx"],
size: 1048576,
created: "2023-07-12",
modified: "2023-08-03",
},
{
path: ["Documents", "Work", "ProjectBeta", "Report.pdf"],
size: 1024000,
created: "2023-06-22",
modified: "2023-07-15",
},
{
path: ["Documents", "Work", "ProjectBeta", "Budget.xlsx"],
size: 1048576,
created: "2023-06-25",
modified: "2023-07-18",
},
{
path: ["Documents", "Work", "Meetings", "TeamMeeting_August.pdf"],
size: 512000,
created: "2023-08-20",
modified: "2023-08-21",
},
{
path: ["Documents", "Work", "Meetings", "ClientMeeting_July.pdf"],
size: 1048576,
created: "2023-07-15",
modified: "2023-07-16",
},
{
path: ["Documents", "Personal", "Taxes", "2022.pdf"],
size: 1024000,
created: "2023-04-10",
modified: "2023-04-10",
},
{
path: ["Documents", "Personal", "Taxes", "2021.pdf"],
size: 1048576,
created: "2022-04-05",
modified: "2022-04-06",
},
{
path: ["Documents", "Personal", "Taxes", "2020.pdf"],
size: 1024000,
created: "2021-04-03",
modified: "2021-04-03",
},
{
path: ["Pictures", "Vacation2019", "Beach.jpg"],
size: 1048576,
created: "2019-07-10",
modified: "2019-07-12",
},
{
path: ["Pictures", "Vacation2019", "Mountain.png"],
size: 2048000,
created: "2019-07-11",
modified: "2019-07-13",
},
{
path: ["Pictures", "Family", "Birthday2022.jpg"],
size: 3072000,
created: "2022-12-15",
modified: "2022-12-20",
},
{
path: ["Pictures", "Family", "Christmas2021.png"],
size: 2048000,
created: "2021-12-25",
modified: "2021-12-26",
},
{
path: ["Videos", "Vacation2019", "Beach.mov"],
size: 4194304,
created: "2019-07-10",
modified: "2019-07-12",
},
{
path: ["Videos", "Vacation2019", "Hiking.mp4"],
size: 4194304,
created: "2019-07-15",
modified: "2019-07-16",
},
{
path: ["Videos", "Family", "Birthday2022.mp4"],
size: 6291456,
created: "2022-12-15",
modified: "2022-12-20",
},
{
path: ["Videos", "Family", "Christmas2021.mov"],
size: 6291456,
created: "2021-12-25",
modified: "2021-12-26",
},
{
path: ["Downloads", "SoftwareInstaller.exe"],
size: 2097152,
created: "2023-08-01",
modified: "2023-08-01",
},
{
path: ["Downloads", "Receipt_OnlineStore.pdf"],
size: 1048576,
created: "2023-08-05",
modified: "2023-08-05",
},
{
path: ["Downloads", "Ebook.pdf"],
size: 1048576,
created: "2023-08-08",
modified: "2023-08-08",
},
];
export function getData() {
return files;
}
This demonstrates the following configuration:
const suppressAggFilteredOnly = true;
<AgGridReact suppressAggFilteredOnly={suppressAggFilteredOnly} /> Filter Components Copy Link
Tree Filter Copy Link
The Tree Filter is a version of the Set Filter that is designed to work with hierarchical data by displaying the set filter in a tree structure that matches the data.
The example below demonstrates the Tree Filter on the Group column:
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetDataPath,
GridApi,
GridOptions,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
SetFilterModule,
TreeDataModule,
} from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
SetFilterModule,
TreeDataModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<any[]>(getData());
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 200,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
cellRendererParams: {
suppressCount: true,
},
filter: "agSetColumnFilter",
filterParams: {
treeList: true,
keyCreator: (params) => (params.value ? params.value.join("#") : null),
},
};
}, []);
const getDataPath = useCallback((data: any) => data.path, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
treeData={true}
groupDefaultExpanded={-1}
getDataPath={getDataPath}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
This demonstrates the following configuration to enable the Tree List Filter. Note that a keyCreator must be used to convert each path into a unique string:
const autoGroupColumnDef = useMemo(() => {
return {
filter: 'agSetColumnFilter',
filterParams: {
treeList: true,
keyCreator: (params) => (params.value ? params.value.join('#') : null),
},
};
}, []);
<AgGridReact autoGroupColumnDef={autoGroupColumnDef} />For further information, refer to the Tree Filter documentation.
Set Filter Copy Link
The Set Filter can be used with Tree Data to list all unique values across each level of the group hierarchy.
The example below demonstrates the Set Filter on the Size column.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetDataPath,
GridApi,
GridOptions,
IsRowFilterable,
ModuleRegistry,
ValueFormatterParams,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
SetFilterModule,
TreeDataModule,
} from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
SetFilterModule,
TreeDataModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<any[]>(getData());
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "created" },
{ field: "modified" },
{
field: "size",
aggFunc: "sum",
filter: "agSetColumnFilter",
filterParams: {
valueFormatter: (params: ValueFormatterParams) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
valueFormatter: (params) => {
if (params.value == null) {
return ""; // params.value can be null/undefined here (e.g. no size for this row)
}
const sizeInKb = params.value / 1024;
if (sizeInKb > 1024) {
return `${+(sizeInKb / 1024).toFixed(2)} MB`;
} else {
return `${+sizeInKb.toFixed(2)} KB`;
}
},
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 200,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
cellRendererParams: {
suppressCount: true,
},
};
}, []);
const getDataPath = useCallback((data: any) => data.path, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
treeData={true}
groupDefaultExpanded={-1}
groupAggFiltering={true}
getDataPath={getDataPath}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
const files = [
{ path: ['Desktop', 'ProjectAlpha', 'Proposal.docx'], size: 512000, created: '2023-07-10', modified: '2023-08-01' },
{
path: ['Desktop', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{ path: ['Desktop', 'ToDoList.txt'], size: 51200, created: '2023-08-05', modified: '2023-08-10' },
{ path: ['Desktop', 'MeetingNotes_August.pdf'], size: 460800, created: '2023-08-15', modified: '2023-08-15' },
{ path: ['Documents', 'Work', 'ProjectAlpha'] },
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Proposal.docx'],
size: 512000,
created: '2023-07-10',
modified: '2023-08-01',
},
{
path: ['Documents', 'Work', 'ProjectAlpha', 'Timeline.xlsx'],
size: 1048576,
created: '2023-07-12',
modified: '2023-08-03',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Report.pdf'],
size: 1024000,
created: '2023-06-22',
modified: '2023-07-15',
},
{
path: ['Documents', 'Work', 'ProjectBeta', 'Budget.xlsx'],
size: 1048576,
created: '2023-06-25',
modified: '2023-07-18',
},
{
path: ['Documents', 'Work', 'Meetings', 'TeamMeeting_August.pdf'],
size: 512000,
created: '2023-08-20',
modified: '2023-08-21',
},
{
path: ['Documents', 'Work', 'Meetings', 'ClientMeeting_July.pdf'],
size: 1048576,
created: '2023-07-15',
modified: '2023-07-16',
},
{
path: ['Documents', 'Personal', 'Taxes', '2022.pdf'],
size: 1024000,
created: '2023-04-10',
modified: '2023-04-10',
},
{
path: ['Documents', 'Personal', 'Taxes', '2021.pdf'],
size: 1048576,
created: '2022-04-05',
modified: '2022-04-06',
},
{
path: ['Documents', 'Personal', 'Taxes', '2020.pdf'],
size: 1024000,
created: '2021-04-03',
modified: '2021-04-03',
},
{ path: ['Pictures', 'Vacation2019', 'Beach.jpg'], size: 1048576, created: '2019-07-10', modified: '2019-07-12' },
{
path: ['Pictures', 'Vacation2019', 'Mountain.png'],
size: 2048000,
created: '2019-07-11',
modified: '2019-07-13',
},
{ path: ['Pictures', 'Family', 'Birthday2022.jpg'], size: 3072000, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Pictures', 'Family', 'Christmas2021.png'], size: 2048000, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Videos', 'Vacation2019', 'Beach.mov'], size: 4194304, created: '2019-07-10', modified: '2019-07-12' },
{ path: ['Videos', 'Vacation2019', 'Hiking.mp4'], size: 4194304, created: '2019-07-15', modified: '2019-07-16' },
{ path: ['Videos', 'Family', 'Birthday2022.mp4'], size: 6291456, created: '2022-12-15', modified: '2022-12-20' },
{ path: ['Videos', 'Family', 'Christmas2021.mov'], size: 6291456, created: '2021-12-25', modified: '2021-12-26' },
{ path: ['Downloads', 'SoftwareInstaller.exe'], size: 2097152, created: '2023-08-01', modified: '2023-08-01' },
{ path: ['Downloads', 'Receipt_OnlineStore.pdf'], size: 1048576, created: '2023-08-05', modified: '2023-08-05' },
{ path: ['Downloads', 'Ebook.pdf'], size: 1048576, created: '2023-08-08', modified: '2023-08-08' },
];
export function getData() {
return files;
}
When using the Set Filter with Aggregations the set filter options can change when applying filters.
To prevent this it is advised that you Enable Aggregate Value Filtering.